diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/ActivatorMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
similarity index 91%
rename from src/main/java/net/minecraft/core/player/inventory/menu/ActivatorMenu.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
index 1cac96c46..9a786aa01 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/ActivatorMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.player.inventory.menu;
 
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.crafting.ContainerListener;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
@@ -10,11 +10,11 @@ import net.minecraft.core.player.inventory.slot.Slot;
 
 import java.util.List;
 
-public class ActivatorMenu extends AbstractContainerMenu {
+public class MenuActivator extends MenuAbstract {
 	public static final int ID_SELECTOR = 0;
 	public static final int ID_LOCKED_SLOTS = 1;
 
-	public ActivatorBlockEntity activator;
+	public TileEntityActivator activator;
 
 	private final int activatorSlotsStart;
 	private final int inventorySlotsStart;
@@ -23,9 +23,9 @@ public class ActivatorMenu extends AbstractContainerMenu {
 	private int selectorSlot;
 	private int lockedSlots;
 
-	public ActivatorMenu(Container container, ActivatorBlockEntity activator) {
+	public MenuActivator(Container container, TileEntityActivator activator) {
 		this.activator = activator;
-		for (int i = 0; i < ActivatorBlockEntity.CONTAINER_SIZE; i++) {
+		for (int i = 0; i < TileEntityActivator.CONTAINER_SIZE; i++) {
 			addSlot(new Slot(activator, i, 8 + i * 18, 35));
 		}
 
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/ContainerMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
similarity index 87%
rename from src/main/java/net/minecraft/core/player/inventory/menu/ContainerMenu.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
index 5ed9aa4bf..eb231d31c 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/ContainerMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
@@ -7,12 +7,12 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.slot.Slot;
 
-public class ContainerMenu extends AbstractContainerMenu {
+public class MenuContainer extends MenuAbstract {
 	
 	private Container container;
 	private int numberOfRows;
 	
-	public ContainerMenu(Container playerContainer, Container container) {
+	public MenuContainer(Container playerContainer, Container container) {
 		this.container = container;
 		numberOfRows = container.getContainerSize() / 9;
 		int i = (numberOfRows - 4) * 18;
@@ -52,7 +52,7 @@ public class ContainerMenu extends AbstractContainerMenu {
 		
 		if(action == InventoryAction.MOVE_ALL) {
 			if(slot.index >= chestSize && slot.index < chestSize + 27) {
-				// Main Inventory
+				// Main ContainerInventory
 				return getSlots(chestSize, 27, false);
 			}
 			if(slot.index >= chestSize + 27 && slot.index < chestSize + 36) {
@@ -61,7 +61,7 @@ public class ContainerMenu extends AbstractContainerMenu {
 			}
 		}else {
 			if(slot.index >= chestSize && slot.index < chestSize + 36) {
-				// Full Inventory
+				// Full ContainerInventory
 				return getSlots(chestSize, 36, false);
 			}
 		}
@@ -75,9 +75,9 @@ public class ContainerMenu extends AbstractContainerMenu {
 		
 		if(slot.index < chestSize) {
 			// Clicked chest
-			return getSlots(chestSize, 36, true); // Inventory
+			return getSlots(chestSize, 36, true); // ContainerInventory
 		}else {
-			// Clicked Inventory
+			// Clicked ContainerInventory
 			return getSlots  (0, chestSize, false); // Chest
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/CraftingMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
similarity index 82%
rename from src/main/java/net/minecraft/core/player/inventory/menu/CraftingMenu.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
index e296a1fae..c95142e4e 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/CraftingMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
@@ -11,33 +11,33 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
-import net.minecraft.core.player.inventory.container.CraftingContainer;
-import net.minecraft.core.player.inventory.container.Inventory;
-import net.minecraft.core.player.inventory.container.ResultContainer;
+import net.minecraft.core.player.inventory.container.ContainerCrafting;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
+import net.minecraft.core.player.inventory.container.ContainerResult;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.ResultSlot;
+import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.world.World;
 
 import java.util.List;
 
-public class CraftingMenu extends AbstractContainerMenu
+public class MenuCrafting extends MenuAbstract
 {
-	public CraftingContainer craftSlots;
+	public ContainerCrafting craftSlots;
 	public Container resultSlots;
 	private World world;
 	private int x;
 	private int y;
 	private int z;
 
-    public CraftingMenu(Inventory inventory, World world, int x, int y, int z)
+    public MenuCrafting(ContainerInventory inventory, World world, int x, int y, int z)
     {
-        craftSlots = new CraftingContainer(this, 3, 3);
-        resultSlots = new ResultContainer();
+        craftSlots = new ContainerCrafting(this, 3, 3);
+        resultSlots = new ContainerResult();
         this.world = world;
         this.x = x;
         this.y = y;
         this.z = z;
-        addSlot(new ResultSlot(inventory.player, craftSlots, resultSlots, 0, 124, 35));
+        addSlot(new SlotResult(inventory.player, craftSlots, resultSlots, 0, 124, 35));
         for(int l = 0; l < 3; l++)
         {
             for(int k1 = 0; k1 < 3; k1++)
@@ -101,7 +101,7 @@ public class CraftingMenu extends AbstractContainerMenu
     /*
      *  0 Craft Result
      *  1 - 9 Crafting (9x)
-     *  10 - 36 Main Inventory (27x)
+     *  10 - 36 Main ContainerInventory (27x)
      *  37 - 45 Hotbar (9x)
      */
     
@@ -117,12 +117,12 @@ public class CraftingMenu extends AbstractContainerMenu
     	}
     	if(action == InventoryAction.MOVE_SIMILAR) {
     		if(slot.index >= 10 && slot.index <= 45) {
-    			// Full Inventory
+    			// Full ContainerInventory
     			return getSlots(10, 36, false);
     		}
     	}else {
     		if(slot.index >= 10 && slot.index <= 36) {
-    			// Main Inventory
+    			// Main ContainerInventory
     			return getSlots(10, 27, false);
     		}
     		if(slot.index >= 37 && slot.index <= 45) {
@@ -136,17 +136,17 @@ public class CraftingMenu extends AbstractContainerMenu
     @Override
     public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
     	if(slot.index >= 10 && slot.index <= 45) {
-    		// Full Inventory
+    		// Full ContainerInventory
     		if(target == 1) {
     			return getSlots(1, 9, false); // To Crafting Grid
     		}
     		if(slot.index >= 10 && slot.index <= 36) {
-    			// Main Inventory
+    			// Main ContainerInventory
     			return getSlots(37, 9, false); // To Hotbar
     		}
     		if(slot.index >= 37 && slot.index <= 45) {
     			// Hotbar
-    			return getSlots(10, 27, false); // To Main Inventory
+    			return getSlots(10, 27, false); // To Main ContainerInventory
     		}
     	}else {
     		// Crafting grid or result
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/FlagMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
similarity index 73%
rename from src/main/java/net/minecraft/core/player/inventory/menu/FlagMenu.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
index c30009e30..bdcd6609a 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/FlagMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
@@ -3,22 +3,22 @@ package net.minecraft.core.player.inventory.menu;
 import java.util.List;
 
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.DyeSlot;
+import net.minecraft.core.player.inventory.slot.SlotDye;
 
-public class FlagMenu extends AbstractContainerMenu {
-	public FlagBlockEntity flag;
+public class MenuFlag extends MenuAbstract {
+	public TileEntityFlag flag;
 
-	public FlagMenu(Container inv, FlagBlockEntity flag) {
+	public MenuFlag(Container inv, TileEntityFlag flag) {
 		this.flag = flag;
 
 		// Dye slots
-		addSlot(new DyeSlot(flag, 36, 129, 10));
-		addSlot(new DyeSlot(flag, 37, 129, 32));
-		addSlot(new DyeSlot(flag, 38, 129, 54));
+		addSlot(new SlotDye(flag, 36, 129, 10));
+		addSlot(new SlotDye(flag, 37, 129, 32));
+		addSlot(new SlotDye(flag, 38, 129, 54));
 
 		// Player inv slots
 		for (int y = 0; y < 3; y++) {
@@ -35,7 +35,7 @@ public class FlagMenu extends AbstractContainerMenu {
 
 	/*
 	 *   0 -   2 Dye Slots
-	 *   3 -  29 Inventory
+	 *   3 -  29 ContainerInventory
 	 *  30 -  38 Hotbar
 	 */
 	@Override
@@ -45,12 +45,12 @@ public class FlagMenu extends AbstractContainerMenu {
 			return getSlots(0, 3, false);
 		}
 		if(action == InventoryAction.MOVE_SIMILAR) {
-			// Full Inventory
+			// Full ContainerInventory
 			return getSlots(3, 36, false);
 		}
 		if(action == InventoryAction.MOVE_ALL) {
 			if(slot.index < 27) {
-				// Main Inventory
+				// Main ContainerInventory
 				return getSlots(3, 27, false);
 			}else {
 				// Hotbar
@@ -64,7 +64,7 @@ public class FlagMenu extends AbstractContainerMenu {
 	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 2) {
 			// Dye Slots
-			return getSlots(3, 36, false); // Into Inventory
+			return getSlots(3, 36, false); // Into ContainerInventory
 		}
 		return getSlots(0, 3, false); // Dye Slots
 	}
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/FurnaceMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
similarity index 85%
rename from src/main/java/net/minecraft/core/player/inventory/menu/FurnaceMenu.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
index 2c3a5c73b..f665658e9 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/FurnaceMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
@@ -3,26 +3,26 @@ package net.minecraft.core.player.inventory.menu;
 import java.util.List;
 
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.FurnaceBlockEntity;
+import net.minecraft.core.block.entity.TileEntityFurnace;
 import net.minecraft.core.crafting.ContainerListener;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.FurnaceSlot;
+import net.minecraft.core.player.inventory.slot.SlotFurnace;
 
-public class FurnaceMenu extends AbstractContainerMenu {
+public class MenuFurnace extends MenuAbstract {
 	public static final int ID_CURRENT_COOK_TIME = 0;
 	public static final int ID_CURRENT_BURN_TIME = 1;
 	public static final int ID_MAX_COOK_TIME = 2;
 	public static final int ID_MAX_BURN_TIME = 3;
 
-	public FurnaceBlockEntity furnace;
+	public TileEntityFurnace furnace;
 	private int currentCookTime;
 	private int currentBurnTime;
 	private int itemBurnTime;
 	private int itemCookTime;
 
-	public FurnaceMenu(Inventory inventory, FurnaceBlockEntity blockEntity) {
+	public MenuFurnace(ContainerInventory inventory, TileEntityFurnace blockEntity) {
 		currentCookTime = 0;
 		currentBurnTime = 0;
 		itemCookTime = 0;
@@ -30,7 +30,7 @@ public class FurnaceMenu extends AbstractContainerMenu {
 		furnace = blockEntity;
 		addSlot(new Slot(blockEntity, 0, 56, 17));
 		addSlot(new Slot(blockEntity, 1, 56, 53));
-		addSlot(new FurnaceSlot(inventory.player, blockEntity, 2, 116, 35));
+		addSlot(new SlotFurnace(inventory.player, blockEntity, 2, 116, 35));
 		for (int i = 0; i < 3; i++) {
 			for (int k = 0; k < 9; k++) {
 				addSlot(new Slot(inventory, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));
@@ -95,7 +95,7 @@ public class FurnaceMenu extends AbstractContainerMenu {
 	 *  0 Input
 	 *  1 Fuel
 	 *  2 Output
-	 *  3 - 29 Main Inventory (27x)
+	 *  3 - 29 Main ContainerInventory (27x)
 	 * 30 - 38 Hotbar (9x)
 	 */
 
@@ -105,7 +105,7 @@ public class FurnaceMenu extends AbstractContainerMenu {
 
 		if(action == InventoryAction.MOVE_ALL) {
 			if(slot.index >= 3 && slot.index <= 30) {
-				// Main Inventory
+				// Main ContainerInventory
 				return getSlots(3, 27, false);
 			}
 			if(slot.index >= 30 && slot.index <= 38) {
@@ -114,7 +114,7 @@ public class FurnaceMenu extends AbstractContainerMenu {
 			}
 		}
 		if(slot.index >= 3 && slot.index <= 38) {
-			// Full Inventory
+			// Full ContainerInventory
 			return getSlots(3, 36, false);
 		}
 		return null;
@@ -123,7 +123,7 @@ public class FurnaceMenu extends AbstractContainerMenu {
 	@Override
 	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 3 && slot.index <= 39) {
-			// Full Inventory
+			// Full ContainerInventory
 			if(action != InventoryAction.MOVE_ALL) {
 				if(target == 1) {
 					return getSlots(0, 1, false); // Into Ingredient Slot
@@ -133,12 +133,12 @@ public class FurnaceMenu extends AbstractContainerMenu {
 				}
 			}
 			if(slot.index >= 3 && slot.index <= 29) {
-				// Main Inventory
+				// Main ContainerInventory
 				return getSlots(30, 9, false); // Into Hotbar
 			}
 			if(slot.index >= 31 && slot.index <= 38) {
 				// Hotbar
-				return getSlots(3, 27, false); // Into Main Inventory
+				return getSlots(3, 27, false); // Into Main ContainerInventory
 			}
 		}
 		if(slot.index >= 0 && slot.index <= 2) {
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/GuidebookMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
similarity index 92%
rename from src/main/java/net/minecraft/core/player/inventory/menu/GuidebookMenu.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
index e7132e011..4f22ccf54 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/GuidebookMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
@@ -7,7 +7,7 @@ import net.minecraft.core.player.inventory.slot.Slot;
 
 import java.util.List;
 
-public class GuidebookMenu extends AbstractContainerMenu
+public class MenuGuidebook extends MenuAbstract
 {
 
 	@Override
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/InventoryMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
similarity index 73%
rename from src/main/java/net/minecraft/core/player/inventory/menu/InventoryMenu.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
index e43e805d9..320838c4b 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/InventoryMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
@@ -6,32 +6,32 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
-import net.minecraft.core.player.inventory.container.CraftingContainer;
-import net.minecraft.core.player.inventory.container.Inventory;
-import net.minecraft.core.player.inventory.container.ResultContainer;
+import net.minecraft.core.player.inventory.container.ContainerCrafting;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
+import net.minecraft.core.player.inventory.container.ContainerResult;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.ArmorSlot;
-import net.minecraft.core.player.inventory.slot.ResultSlot;
+import net.minecraft.core.player.inventory.slot.SlotArmor;
+import net.minecraft.core.player.inventory.slot.SlotResult;
 
 import java.util.List;
 
-public class InventoryMenu extends AbstractContainerMenu {
+public class MenuInventory extends MenuAbstract {
 
-	public CraftingContainer craftSlots;
+	public ContainerCrafting craftSlots;
 	public Container resultSlots;
 	public boolean active;
-	public Inventory inventory;
+	public ContainerInventory inventory;
 
-	public InventoryMenu(Inventory inventory) {
+	public MenuInventory(ContainerInventory inventory) {
 		this(inventory, true);
 	}
 
-	public InventoryMenu(Inventory inventory, boolean active) {
-		craftSlots = new CraftingContainer(this, 2, 2);
-		resultSlots = new ResultContainer();
+	public MenuInventory(ContainerInventory inventory, boolean active) {
+		craftSlots = new ContainerCrafting(this, 2, 2);
+		resultSlots = new ContainerResult();
 		this.active = active;
 		this.inventory = inventory;
-		addSlot(new ResultSlot(inventory.player, craftSlots, resultSlots, 0, 144, 36));
+		addSlot(new SlotResult(inventory.player, craftSlots, resultSlots, 0, 144, 36));
 		
 		for (int i = 0; i < 2; i++) {
 			for (int j = 0; j < 2; j++) {
@@ -41,7 +41,7 @@ public class InventoryMenu extends AbstractContainerMenu {
 		
 		for (int i = 0; i < 4; i++) {
 			int armorType = IArmorItem.PIECE_HEAD - i;
-			addSlot(new ArmorSlot(this, inventory, inventory.getContainerSize() - 1 - i, 8, 8 + i * 18, armorType));
+			addSlot(new SlotArmor(this, inventory, inventory.getContainerSize() - 1 - i, 8, 8 + i * 18, armorType));
 		}
 		
 		for (int i = 0; i < 3; i++) {
@@ -88,7 +88,7 @@ public class InventoryMenu extends AbstractContainerMenu {
 	 *  0 Craft Result
 	 *  1 -  4 Crafting (4x)
 	 *  5 -  8 Armor (4x)
-	 *  9 - 35 Main Inventory (27x)
+	 *  9 - 35 Main ContainerInventory (27x)
 	 * 36 - 44 Hotbar (9x)
 	 */
 
@@ -108,12 +108,12 @@ public class InventoryMenu extends AbstractContainerMenu {
 		}
 		if(action == InventoryAction.MOVE_SIMILAR) {
 			if(slot.index >= 9 && slot.index <= 44) {
-				// Full Inventory
+				// Full ContainerInventory
 				return getSlots(9, 36, false);
 			}	
 		}else {
 			if(slot.index >= 9 && slot.index <= 35) {
-				// Main Inventory
+				// Main ContainerInventory
 				return getSlots(9, 27, false);
 			}
 			if(slot.index >= 36 && slot.index <= 44) {
@@ -127,7 +127,7 @@ public class InventoryMenu extends AbstractContainerMenu {
 	@Override
 	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 9 && slot.index <= 44) {
-			// Full Inventory
+			// Full ContainerInventory
 			if(target == 1) {
 				return getSlots(1, 4, false); // Crafting
 			}
@@ -136,19 +136,19 @@ public class InventoryMenu extends AbstractContainerMenu {
 			}
 			
 			if(slot.index < 36) {
-				// Main Inventory
+				// Main ContainerInventory
 				return getSlots(36, 9, false); // Hotbar
 			}else {
 				// Hotbar
-				return getSlots(9, 27, false); // Main Inventory
+				return getSlots(9, 27, false); // Main ContainerInventory
 			}
 		}else {
 			if(slot.index == 0) {
 				// Crafting Result
-				return getSlots(9, 36, true); // Full Inventory, Last First
+				return getSlots(9, 36, true); // Full ContainerInventory, Last First
 			}else {
 				// Crafting Grid and Armor
-				return getSlots(9, 36, false); // Full Inventory
+				return getSlots(9, 36, false); // Full ContainerInventory
 			}
 			
 		}
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/CreativeInventoryMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
similarity index 88%
rename from src/main/java/net/minecraft/core/player/inventory/menu/CreativeInventoryMenu.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index b07072708..0aa4b84ee 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/CreativeInventoryMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -8,13 +8,13 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.player.inventory.container.Inventory;
-import net.minecraft.core.player.inventory.slot.CreativeSlot;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
+import net.minecraft.core.player.inventory.slot.SlotCreative;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class CreativeInventoryMenu extends InventoryMenu
+public class MenuInventoryCreative extends MenuInventory
 {
 	public int page = 0;
 	public int maxPage;
@@ -22,12 +22,12 @@ public class CreativeInventoryMenu extends InventoryMenu
 	protected List<ItemStack> searchedItems = new ArrayList<ItemStack>();
 	public String searchText = "";
 	
-	public CreativeInventoryMenu(Inventory inventoryplayer)
+	public MenuInventoryCreative(ContainerInventory inventoryplayer)
 	{
 		this(inventoryplayer, true);
 	}
 	
-	public CreativeInventoryMenu(Inventory inventoryplayer, boolean isNotClientSide)
+	public MenuInventoryCreative(ContainerInventory inventoryplayer, boolean isNotClientSide)
 	{
 		super(inventoryplayer, isNotClientSide);
 		
@@ -39,7 +39,7 @@ public class CreativeInventoryMenu extends InventoryMenu
 			int x = i % 6;
 			int y = i / 6;
 			
-			addSlot(new CreativeSlot(creativeSlotsStart + i, 184 + (x * 18), 30 + (y * 18), creativeItems.get(i)));
+			addSlot(new SlotCreative(creativeSlotsStart + i, 184 + (x * 18), 30 + (y * 18), creativeItems.get(i)));
 		}
 		
 		searchPage("");
@@ -103,11 +103,11 @@ public class CreativeInventoryMenu extends InventoryMenu
 		{
 			if (i + (page * 36) >= searchedItems.size())
 			{
-				((CreativeSlot)this.slots.get(creativeSlotsStart + i)).item = null;
+				((SlotCreative)this.slots.get(creativeSlotsStart + i)).item = null;
 			}
 			else
 			{
-				((CreativeSlot)this.slots.get(creativeSlotsStart + i)).item = searchedItems.get(i + (page * 36));
+				((SlotCreative)this.slots.get(creativeSlotsStart + i)).item = searchedItems.get(i + (page * 36));
 			}			
 		}
 		
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/TrapMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java
similarity index 90%
rename from src/main/java/net/minecraft/core/player/inventory/menu/TrapMenu.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java
index ded9ce91e..ecb705d86 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/TrapMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java
@@ -3,20 +3,20 @@ package net.minecraft.core.player.inventory.menu;
 import java.util.List;
 
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.DispenserBlockEntity;
+import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.slot.Slot;
 
-public class TrapMenu extends AbstractContainerMenu {
+public class MenuTrap extends MenuAbstract {
 
-	public DispenserBlockEntity trap;
+	public TileEntityDispenser trap;
 	
 	private int dispenserSlotsStart;
 	private int inventorySlotsStart;
 	private int hotbarSlotsStart;
 
-	public TrapMenu(Container container, DispenserBlockEntity trap) {
+	public MenuTrap(Container container, TileEntityDispenser trap) {
 		this.trap = trap;
 		for (int i = 0; i < 3; i++) {
 			for (int l = 0; l < 3; l++) {
diff --git a/src/main/java/net/minecraft/core/player/inventory/menu/TrommelMenu.java b/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
similarity index 85%
rename from src/main/java/net/minecraft/core/player/inventory/menu/TrommelMenu.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
index 843f95aa9..89fd3d854 100644
--- a/src/main/java/net/minecraft/core/player/inventory/menu/TrommelMenu.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
@@ -3,21 +3,21 @@ package net.minecraft.core.player.inventory.menu;
 import java.util.List;
 
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.TrommelBlockEntity;
+import net.minecraft.core.block.entity.TileEntityTrommel;
 
 import net.minecraft.core.crafting.ContainerListener;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 
-public class TrommelMenu extends AbstractContainerMenu {
+public class MenuTrommel extends MenuAbstract {
 
-	private TrommelBlockEntity trommel;
+	private TileEntityTrommel trommel;
 	private int cookTime = 0;
 	private int burnTime = 0;
 	private int itemBurnTime = 0;
 
-	public TrommelMenu(Inventory inventoryplayer, TrommelBlockEntity tileEntityTrommel) {
+	public MenuTrommel(ContainerInventory inventoryplayer, TileEntityTrommel tileEntityTrommel) {
 		trommel = tileEntityTrommel;
 		
 		// Item Slots
@@ -81,7 +81,7 @@ public class TrommelMenu extends AbstractContainerMenu {
 	/*
 	 *  0 - 3 Item Slots
 	 *  4 Fuel Slot
-	 *  5 - 31 Inventory
+	 *  5 - 31 ContainerInventory
 	 * 32 - 40 Hotbar
 	 */
 
@@ -95,7 +95,7 @@ public class TrommelMenu extends AbstractContainerMenu {
 		}
 		if(action == InventoryAction.MOVE_ALL) {
 			if(slot.index >= 5 && slot.index <= 31) {
-				// Main Inventory
+				// Main ContainerInventory
 				return getSlots(5, 27, false);
 			}
 			if(slot.index >= 32 && slot.index <= 40) {
@@ -105,7 +105,7 @@ public class TrommelMenu extends AbstractContainerMenu {
 		}
 		if(action == InventoryAction.MOVE_SIMILAR) {
 			if(slot.index >= 5 && slot.index <= 40) {
-				// Full Inventory
+				// Full ContainerInventory
 				return getSlots(5, 36, false);
 			}
 		}
@@ -116,7 +116,7 @@ public class TrommelMenu extends AbstractContainerMenu {
 	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 4) {
 			// Item and Fuel Slots
-			return getSlots(5, 36, false); // Into Inventory
+			return getSlots(5, 36, false); // Into ContainerInventory
 		}
 		if(slot.index >= 5 && slot.index <= 40) {
 			if(target == 1) {
@@ -127,12 +127,12 @@ public class TrommelMenu extends AbstractContainerMenu {
 			}
 			
 			if(slot.index >= 5 && slot.index <= 31) {
-				// Main Inventory
+				// Main ContainerInventory
 				return getSlots(32, 9, false); // Into hotbar
 			}
 			if(slot.index >= 32 && slot.index <= 40) {
 				// Hotbar
-				return getSlots(5, 27, false); // Into Inventory
+				return getSlots(5, 27, false); // Into ContainerInventory
 			}
 		}
 		return null;
diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java b/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
index 64d5110c2..a82c5edde 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
+++ b/src/main/java/net/minecraft/core/player/inventory/slot/Slot.java
@@ -6,7 +6,7 @@ package net.minecraft.core.player.inventory.slot;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.container.Inventory;
+import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.container.Container;
 import org.jetbrains.annotations.Nullable;
 
@@ -89,9 +89,9 @@ public class Slot
 		container.setItem(slot, itemstack);
 		setChanged();
 
-		if (container instanceof Inventory)
+		if (container instanceof ContainerInventory)
 		{
-			final Inventory inventory = (Inventory) this.container;
+			final ContainerInventory inventory = (ContainerInventory) this.container;
 
 			if(itemstack != null)
 				inventory.player.addStat(itemstack.getItem().getStat(StatList.STAT_PICKED_UP), 1);
